import java.io.*;
import java.util.*;

import org.xml.sax.*;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;

public class countElement extends DefaultHandler
{
  public static void main(String argv[])
  {
    if (argv.length != 1) {
      System.err.println("Usage: java countElement xmlfilename");
      System.exit(1);
    }

     // Use an instance of ourselves as the SAX event handler
    DefaultHandler handler = new countElement();
    // Use the default (non-validating) parser
    SAXParserFactory factory = SAXParserFactory.newInstance();

     try {
      SAXParser saxParser = factory.newSAXParser();
      saxParser.parse(new File(argv [0]), handler);

	  //  print elementCounts
	  Iterator<String> iterator = elementCounts.keySet().iterator();
	  while (iterator.hasNext())
	  {  String name = iterator.next();
	     System.out.println("<" + name + ">: " + elementCounts.get(name) + ".");
	  }
     } catch (Throwable t) {
      t.printStackTrace();
    }
  }

  // Data members
  static private HashMap<String, Integer> elementCounts 
		= new HashMap<String, Integer>();

  // Handler methods
  public void startElement(String namespaceURI,
      String lName, // local name
      String qName, // qualified name
      Attributes attrs)
    throws SAXException
  {
    String eName = lName; // element name
    if ("".equals(eName)) eName = qName; // namespaceAware = false
 
	//  Increment the element count.
    if (elementCounts.containsKey(eName)) 
	{	elementCounts.put(eName, new Integer(elementCounts.get(eName).intValue()+1));
	}
	else
	{  elementCounts.put(eName, new Integer(1));
	}
  } // startElement
} // countElement.